diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 967c41a63..d219fe60f 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -24,7 +24,6 @@ import net.minecraft.client.gui.*;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.chat.ScreenSleepMP;
-import net.minecraft.client.gui.options.data.OptionsPage;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
@@ -59,7 +58,7 @@ import net.minecraft.core.net.command.commands.CommandSeed;
 import net.minecraft.core.net.command.commands.CommandSetBlock;
 import net.minecraft.core.net.command.commands.CommandSetSpawn;
 import net.minecraft.core.net.command.commands.CommandSpawn;
-import net.minecraft.core.net.command.commands.CommandSpawnParticle;
+import net.minecraft.core.net.command.commands.CommandParticle;
 import net.minecraft.core.net.command.commands.CommandSummon;
 import net.minecraft.core.net.command.commands.CommandTeleport;
 import net.minecraft.core.net.command.commands.CommandTellRaw;
@@ -128,7 +127,6 @@ import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.terrain.TerrainRenderer;
 import net.minecraft.client.render.terrain.TerrainRendererLegacy;
-import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePackList;
@@ -714,7 +712,7 @@ public class Minecraft
         CommandManager.registerCommand(new CommandHeal());
         CommandManager.registerCommand(new CommandMobSpawning());
         CommandManager.registerCommand(new CommandPlaySound());
-        CommandManager.registerCommand(new CommandSpawnParticle());
+        CommandManager.registerCommand(new CommandParticle());
     }
     
     private void printWrongJavaVersionInfo() {
@@ -1421,7 +1419,7 @@ public class Minecraft
         }
     }
 
-    private void clickMiddleMouseButton()
+    private void clickMiddleMouseButton(boolean shift, boolean control)
     {
         HitResult mouseOver = thePlayer.rayTrace(256, timer.partialTicks, false, false);
         if(mouseOver != null && mouseOver.hitType == HitResult.HitType.TILE)
@@ -1429,7 +1427,7 @@ public class Minecraft
             int x = mouseOver.x;
             int y = mouseOver.y;
             int z = mouseOver.z;
-            thePlayer.pickBlock(x, y, z);
+            thePlayer.pickBlock(x, y, z, control);
         }
     }
 
@@ -1865,7 +1863,7 @@ public class Minecraft
 
         // Pick block
         if (gameSettings.keyPickBlock.isPressEvent(currentInputDevice)) {
-            clickMiddleMouseButton();
+            clickMiddleMouseButton(shift, control);
             return true;
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index a1d134c22..9421d05ab 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -71,6 +71,13 @@ public class PlayerLocal extends Player
         uuid = session.uuid;
 
         playerConfig.setLeftHand(minecraft.gameSettings.playerLeftHanded.value);
+        playerConfig.setCape(minecraft.gameSettings.playerCape.value);
+        playerConfig.setHat(minecraft.gameSettings.playerHat.value);
+        playerConfig.setJacket(minecraft.gameSettings.playerJacket.value);
+        playerConfig.setSleeveLeft(minecraft.gameSettings.playerSleeveLeft.value);
+        playerConfig.setSleeveRight(minecraft.gameSettings.playerSleeveRight.value);
+        playerConfig.setPantLeft(minecraft.gameSettings.playerPantLeft.value);
+        playerConfig.setPantRight(minecraft.gameSettings.playerPantRight.value);
 
         new GetSkinUrlThread(this);
         LOGGER.info("logged in with session name: {}", username);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 1f68a30b4..d96ea6cb2 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -11,7 +11,6 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.net.packet.PacketBoatControl;
 import net.minecraft.core.net.packet.PacketChat;
-import net.minecraft.core.net.packet.PacketContainerSetSlot;
 import net.minecraft.core.net.packet.PacketPlayerConfig;
 import net.minecraft.core.net.packet.PacketUpdatePlayerState;
 import net.minecraft.core.net.packet.PacketMovePlayer;
@@ -277,8 +276,8 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     }
     
     @Override
-    public void pickBlock(int x, int y, int z) {
-    	sendQueue.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
+    public void pickBlock(int x, int y, int z, boolean pickFully) {
+    	sendQueue.addToSendQueue(new PacketPlayerAction(pickFully ? PacketPlayerAction.ACTION_PICK_BLOCK_FULLY : PacketPlayerAction.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 46ca59dcc..1c250c023 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -118,7 +118,7 @@ public class ScreenMainMenu extends Screen
                 codeProgress = 0;
             }
         }
-        else
+        else if (eventKey != -1)
         {
             codeProgress = 0;
         }
@@ -384,7 +384,7 @@ public class ScreenMainMenu extends Screen
     	}
     }
 
-    private void drawLogo(float var1) {
+    private void drawLogo(final float partialTick) {
         int var3;
         if(this.logoBlocks == null) {
             this.logoBlocks = new LogoBlock[logoBlockLayers[0].length()][logoBlockLayers.length];
@@ -399,7 +399,7 @@ public class ScreenMainMenu extends Screen
         GL11.glMatrixMode(GL11.GL_PROJECTION);
         GL11.glPushMatrix();
         GL11.glLoadIdentity();
-        int delta = mc.gameWindow.getWidthPixels() / mc.resolution.getScaledWidthScreenCoords();
+        final int delta = this.mc.gameWindow.getWidthPixels() / this.mc.resolution.getScaledWidthScreenCoords();
         var3 = 120 * delta;
         GLU.gluPerspective(70.0F, (float)this.mc.gameWindow.getWidthPixels() / (float)var3, 0.05F, 100.0F);
         GL11.glViewport(0, this.mc.gameWindow.getHeightPixels() - var3, this.mc.gameWindow.getWidthPixels(), var3);
@@ -410,27 +410,27 @@ public class ScreenMainMenu extends Screen
         GL11.glCullFace(GL11.GL_BACK);
         GL11.glDepthMask(true);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
-        Lighting.enableLight();
+        Lighting.enableLight(0.5f, 0.16f);
         
-        for(int var4 = 0; var4 < 3; ++var4) {
+        for(int renderPass = 0; renderPass < 3; ++renderPass) {
             GL11.glPushMatrix();
             GL11.glTranslatef(0.4F, 0.6F, -12.0F);
-            if(var4 == 0) {
-                GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
-                GL11.glTranslatef(0.0F, -0.4F, 0.0F);
-                GL11.glScalef(0.98F, 1.0F, 1.0F);
-                GL11.glEnable(GL11.GL_BLEND);
-                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            }
-
-            if(var4 == 1) {
-                GL11.glDisable(GL11.GL_BLEND);
-                GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
-            }
-
-            if(var4 == 2) {
-                GL11.glEnable(GL11.GL_BLEND);
-                GL11.glBlendFunc(GL11.GL_SRC_COLOR, GL11.GL_ONE);
+            switch (renderPass) {
+                case 0:
+                    GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
+                    GL11.glTranslatef(0.0F, -0.4F, 0.0F);
+                    GL11.glScalef(0.98F, 1.0F, 1.0F);
+                    GL11.glEnable(GL11.GL_BLEND);
+                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+                    break;
+                case 1:
+                    GL11.glDisable(GL11.GL_BLEND);
+                    GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
+                    break;
+                case 2:
+                    GL11.glEnable(GL11.GL_BLEND);
+                    GL11.glBlendFunc(GL11.GL_SRC_COLOR, GL11.GL_ONE);
+                    break;
             }
 
             GL11.glScalef(1.0F, -1.0F, 1.0F);
@@ -438,20 +438,20 @@ public class ScreenMainMenu extends Screen
             GL11.glScalef(0.89F, 1.0F, 0.4F);
             GL11.glTranslatef((float)(-logoBlockLayers[0].length()) * 0.5F, (float)(-logoBlockLayers.length) * 0.5F, 0.0F);
             TextureRegistry.blockAtlas.bind();
-            if(var4 == 0) {
+            if(renderPass == 0) {
                 this.mc.textureManager.loadTexture("/title/black.png").bind();
             }
 
             for(int y = 0; y < logoBlockLayers.length; ++y) {
                 for(int x = 0; x < logoBlockLayers[y].length(); ++x) {
-                    char var8 = logoBlockLayers[y].charAt(x);
-                    if(var8 != ' ') {
+                    char c = logoBlockLayers[y].charAt(x);
+                    if(c != ' ') {
                         GL11.glPushMatrix();
-                        LogoBlock var9 = this.logoBlocks[x][y];
-                        float z = (float)(var9.prevHeight + (var9.height - var9.prevHeight) * (double)var1);
+                        final LogoBlock logoBlock = this.logoBlocks[x][y];
+                        float z = (float)(logoBlock.prevHeight + (logoBlock.height - logoBlock.prevHeight) * (double)partialTick);
                         float scale = 1.0F;
                         float alpha = 1.0F;
-                        if(var4 == 0) {
+                        if(renderPass == 0) {
                             scale = z * 0.04F + 1.0F;
                             alpha = 1.0F / scale;
                             z = 0.0F;
@@ -459,7 +459,7 @@ public class ScreenMainMenu extends Screen
 
                         GL11.glTranslatef(x, y, z);
                         GL11.glScalef(scale, scale, scale);
-                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[indexToDraw]).renderStandalone(Tessellator.instance, 0, 1f, alpha, null);
+                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(Tessellator.instance, 0, 1f, alpha, null);
                         GL11.glPopMatrix();
                     }
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index ff44062bb..f768851c5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -240,6 +240,7 @@ public class TooltipElement extends Gui
 		if(discovered) {
 			text.append(TextFormatting.get(itemStack.getDisplayColor()));
 			text.append(itemStack.getDisplayName());
+            if (itemStack.getData().containsKey("tileEntityData")) text.append(" ").append(TextFormatting.MAGENTA).append(TextFormatting.ITALIC).append("+NBT").append(TextFormatting.RESET).append(TextFormatting.get(itemStack.getDisplayColor()));
 
 
             if(debug) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index f6082c1c2..53731bc4c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -340,7 +340,7 @@ public class GuiElementChatSuggestions extends Gui {
     }
 
     public void scroll(int amount) {
-        this.scroll = MathHelper.clamp(scroll + amount, 0, this.suggestions.size() - MAX_SUGGESTIONS);
+        this.scroll = MathHelper.clamp(scroll + amount, 0, Math.max(this.suggestions.size() - MAX_SUGGESTIONS, 0));
     }
 
     public void cycleThroughSuggestions() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 044ca43de..26d4e249a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.chat;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
@@ -11,9 +12,10 @@ import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.gui.text.ITextField;
 import org.lwjgl.input.Mouse;
+import org.slf4j.Logger;
 
 public class ScreenChat extends Screen implements ITextField {
-
+	protected static final Logger LOGGER = LogUtils.getLogger();
 	protected String message;
 	private int currentIndex = 0;
 	private String originalMessage;
@@ -183,40 +185,44 @@ public class ScreenChat extends Screen implements ITextField {
 
 	@Override
 	public void render(int mx, int my, float partialTick) {
-		// Draw emote picker button
-		int emotePickerButtonColor = 0x80000000;
-		int emotePickerTextColor = 0xE0E0E0;
-		if (mx >= 2 && mx < 14 && my >= height - 14 && my < height - 2)
-		{
-			emotePickerButtonColor = 0x80ffffff;
-			emotePickerTextColor = 0xffffffa0;
-		}
-		drawRect(2, height - 14, 14, height - 2, emotePickerButtonColor);
-		drawStringCentered(font, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
+		try {
+			// Draw emote picker button
+			int emotePickerButtonColor = 0x80000000;
+			int emotePickerTextColor = 0xE0E0E0;
+			if (mx >= 2 && mx < 14 && my >= height - 14 && my < height - 2)
+			{
+				emotePickerButtonColor = 0x80ffffff;
+				emotePickerTextColor = 0xffffffa0;
+			}
+			drawRect(2, height - 14, 14, height - 2, emotePickerButtonColor);
+			drawStringCentered(font, Character.toString('\u263a'), 2 + 6, height - 12, emotePickerTextColor);
 
-		drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
+			drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
 
-		font.drawStringWithShadow(this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
-		drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
-		boolean drawCursor = (updateCounter / 6) % 2 == 0;
-		int cursor = editor.getCursor();
-		if (drawCursor)
-		{
-			int width = font.getStringWidth(message);
-			if (cursor < message.length())
+			font.drawStringWithShadow(this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
+			boolean drawCursor = (updateCounter / 6) % 2 == 0;
+			int cursor = editor.getCursor();
+			drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
+			if (drawCursor)
 			{
-				width = font.getStringWidth(message.substring(0, cursor));
+				int width = font.getStringWidth(message);
+				if (cursor < message.length())
+				{
+					width = font.getStringWidth(message.substring(0, cursor));
+				}
+				drawString(font, "_", 18 + width, height - 12, 0xE0E0E0);
 			}
-			drawString(font, "_", 18 + width, height - 12, 0xE0E0E0);
-		}
 
-		if (showEmotePicker) {
-			emotePicker.draw(2, height - 16 - emotePicker.getHeight(), mx, my);
-		}
+			if (showEmotePicker) {
+				emotePicker.draw(2, height - 16 - emotePicker.getHeight(), mx, my);
+			}
 
-		super.render(mx, my, partialTick);
-		if (this.suggestionsElement != null) {
-			this.suggestionsElement.drawScreen();
+			super.render(mx, my, partialTick);
+			if (this.suggestionsElement != null) {
+				this.suggestionsElement.drawScreen();
+			}
+		} catch (Exception e) {
+			LOGGER.error("Exception while attempting to render chat gui!", e);
 		}
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index b8b4df54c..4a308f6da 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -106,22 +106,22 @@ public class HudIngame extends Gui
         }
 
         // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
-        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id()))
+        final ItemStack headSlotItem = this.mc.thePlayer.inventory.armorItemInSlot(HumanArmorShape.HEAD);
+        if (this.mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id()))
         {
             renderPumpkinBlur(width, height);
         }
 
         // Render portal overlay
-        float portalIntensity = mc.thePlayer.prevTimeInPortal + (mc.thePlayer.timeInPortal - mc.thePlayer.prevTimeInPortal) * partialTicks;
+        final float portalIntensity = MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTicks);
         if (portalIntensity > 0.0F)
         {
             renderPortalOverlay(portalIntensity, width, height);
         }
 
-        for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-            if (component.isVisible(mc) && component.isEnabled(mc)) {
-                component.render(mc, this, width - sp * 2, height - sp * 2, partialTicks);
+        for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
+            if (component.isVisible(this.mc)) {
+                component.render(this.mc, this, width - sp * 2, height - sp * 2, partialTicks);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 2627145ab..855f530a5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -381,7 +381,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
         scroll(Mouse.getDWheel());
 
-        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
+//        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
         drawStringCentered(font, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 4472d7644..0a474d34d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -32,10 +32,11 @@ public abstract class OptionsPages
     private static final Minecraft mc = Minecraft.getMinecraft();
     private static boolean hasInit = false;
     public static OptionsPage GENERAL;
-
+    public static OptionsPage PLAYER;
     public static OptionsPage AUDIO;
     public static OptionsPage VIDEO;
     public static OptionsPage CONTROLS;
+    public static OptionsPage ACCESSIBILITY;
     public static OptionsPage TEXTURE_PACKS;
     public static OptionsPage LANGUAGE;
     public static OptionsPage SEARCH;
@@ -60,7 +61,6 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.autoHit))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.easyBridge))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.viewBobbing))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerLeftHanded))
             )
             .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
                 .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new ScreenHudDesigner(mc.currentScreen))))
@@ -86,12 +86,26 @@ public abstract class OptionsPages
             )
             .withComponent(new ShortcutComponent("gui.options.page.general.button.open_worlds_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "saves"))))
             .withComponent(new ShortcutComponent("gui.options.page.general.button.open_screenshots_folder", () -> {
-                File f = new File(mc.getMinecraftDir(), "screenshots");
+                final File f = new File(mc.getMinecraftDir(), "screenshots");
+                //noinspection ResultOfMethodCallIgnored
                 f.mkdirs();
                 Utils.openDirectory(f);
             }))
         );
 
+        PLAYER = register(new OptionsPage("gui.options.page.player.title", new ItemStack(Items.STATUE_STONE))
+            .withComponent(new OptionsCategory("gui.options.page.player.category.player")
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerLeftHanded))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerCape))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerHat))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerJacket))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerSleeveLeft))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerSleeveRight))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerPantLeft))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerPantRight))
+            )
+        );
+
         AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Items.RECORD_CAT))
             .withComponent(new OptionsCategory("gui.options.page.audio.category.audio")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.subtitles))
@@ -106,7 +120,7 @@ public abstract class OptionsPages
             )
         );
 
-        ToggleableOptionComponent<?> lightmapComponent = new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle);
+        final OptionsComponent lightmapComponent = new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle);
 
         VIDEO = register(new OptionsPage("gui.options.page.video.title", new ItemStack(Items.FLAG))
             .withComponent(new OptionsCategory("gui.options.page.video.category.graphics")
@@ -135,6 +149,8 @@ public abstract class OptionsPages
             .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
                 .withComponent(Minecraft.GPU_VENDOR == EnumGPUVendor.INTEL ? null : lightmapComponent)
                 .withComponent(new FloatOptionComponent(mc.gameSettings.brightness))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.fovModification))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.screenMotionEffects))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.biomeWater))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.treeShadows))
@@ -238,6 +254,20 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyShowConsole))
             )
         );
+
+        ACCESSIBILITY = register(new OptionsPage("gui.options.page.accessibility.title", new ItemStack(Items.WAND_MONSTER_SPAWNER))
+            .withComponent(new OptionsCategory("gui.options.page.accessibility.category.accessibility")
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.subtitles))
+                .withComponent(new IntegerOptionComponent(mc.gameSettings.guiScale))
+                .withComponent(new FloatOptionComponent(mc.gameSettings.screenPadding))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.viewBobbing))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.fovModification))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.screenMotionEffects))
+                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.colorblindnessFix))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.turnWithVehicle))
+            )
+        );
+
         TEXTURE_PACKS = register(new OptionsPage("gui.options.page.texture_packs.title", new ItemStack(Items.PAINTING))
             .withComponent(new ShortcutComponent("gui.options.page.texture_packs.button.open_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "texturepacks"))))
             .withComponent(new OptionsCategory("gui.options.page.texture_packs.category.textures")
@@ -309,8 +339,8 @@ public abstract class OptionsPages
                                    mc.changeWorld(new WorldClient(), "Loading Model Viewer");
                                    mc.displayScreen(new ScreenModelViewer());}) {
                                    @Override
-                                   public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-                                       button.enabled = mc.currentWorld == null;
+                                   public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                                       this.button.enabled = mc.currentWorld == null;
                                        super.render(x, y, width, relativeMouseX, relativeMouseY);
                                    }
                                }
@@ -330,7 +360,7 @@ public abstract class OptionsPages
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.test")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.music.skip", () -> {
-                    SoundSystem soundSystem = SoundEngine.getSoundSystem();
+                    final SoundSystem soundSystem = SoundEngine.getSoundSystem();
                     if (soundSystem != null) {
                         soundSystem.stop(SoundEngine.BG_MUSIC);
                     }
@@ -341,8 +371,8 @@ public abstract class OptionsPages
                     mc.currentWorld.getLevelData().setCheatsEnabled(true);
                 }) {
                     @Override
-                    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-                        button.enabled = (mc.currentWorld != null && !mc.currentWorld.isClientSide);
+                    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                        this.button.enabled = (mc.currentWorld != null && !mc.currentWorld.isClientSide);
                         super.render(x, y, width, relativeMouseX, relativeMouseY);
                     }
                 })
@@ -350,7 +380,7 @@ public abstract class OptionsPages
                     mc.statsCounter.wipe("I want to delete all the saved stats");
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.unlockedall", () -> {
-                    for (Stat stat : StatList.getAllStats()){
+                    for (final Stat stat : StatList.getAllStats()){
                         mc.thePlayer.addStat(stat, mc.thePlayer.getStat(stat) == 0 ? 1 : 0);
                     }
                 }))
